select
  (select idweb from fazenda) || LPAD(an.cdanimal,  6, '0')  as codigo_animal
  , ea.dtexame as data_opg
  , ea.valor as contagem_opg
  , apec.dtaplicacaoproduto as data_carrapaticida
  , pec.nome as carrapaticida_utilizado
  , apen.dtaplicacaoproduto as data_vermifugacao
  , pen.nome as vermifugo_utilizado
from animal an
  join exameanimal ea on ea.cdanimal = an.cdanimal and ea.cdexame = (select cdexame from exame where descricao = 'OPG')
  left join aplicacaoproduto apec on  apec.cdaplicacaoproduto = 
    (select first 1 re.cdaplicacaoproduto
    from aplicacaoproduto re
    where re.cdanimal = ea.cdanimal
      and re.cdproduto in (select cdproduto from produto where cdclassificacao in (select cdclassificacao from classificacao where  descricao like '%Ectoparasiticida%'))
    order by re.dtaplicacaoproduto desc)
  left join produto pec on pec.cdproduto = apec.cdproduto
  left join aplicacaoproduto apen on  apen.cdaplicacaoproduto = 
    (select first 1 re.cdaplicacaoproduto
    from aplicacaoproduto re
    where re.cdanimal = ea.cdanimal
      and re.cdproduto in (select cdproduto from produto where cdclassificacao in (select cdclassificacao from classificacao where  descricao like '%Endectocida%'))
    order by re.dtaplicacaoproduto desc)
    left join produto pen on pen.cdproduto = apen.cdproduto
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is null
  and ea.dtexame >= coalesce((select first 1 dtinicio from lactacao where cdanimal = an.cdanimal order by dtinicio desc), an.dtnascimento)
order by an.numordenado