select
  (select idweb from fazenda) || LPAD(an.cdanimal,  6, '0')  as codigo_animal
  , (case when an.nome = '' or an.nome is null then an.numero else an.nome end) as nome_animal
  , (case cat.cbasica 
    when 5 then 'Bezerra'
      || (case when an.dtdesmama is null then ' mamando' else ' desmamada' end)
    when 6 then 'Novilha em crescimento'
    when 7 then 'Vaca'
      || (case cat.cprodutiva
        when 4 then ' em Lactação'
        when 3 then ' Seca'
        else '' end)
    else null end) as categoria
  , (case
    when (((select first 1 re.cdraca from animalraca re where re.cdanimal = an.cdanimal and re.cdraca = 365 and percentual = 100)>0))
    then 'holandesa'
    when (((select first 1 re.cdraca from animalraca re where re.cdanimal = an.cdanimal and re.cdraca = 365 and percentual = 75)>0)
      and ((select first 1 re.cdraca from animalraca re where re.cdanimal = an.cdanimal and re.cdraca = 300 and percentual = 25)>0))
    then '3/4 holandes 1/4 gir'
    when (((select first 1 re.cdraca from animalraca re where re.cdanimal = an.cdanimal and re.cdraca = 365 and percentual = 50)>0)
      and ((select first 1 re.cdraca from animalraca re where re.cdanimal = an.cdanimal and re.cdraca = 300 and percentual = 50)>0))
    then '1/2 sangue holandes 1/2 sangue gir'
    when ((select first 1 re.cdraca from animalraca re where re.cdanimal = an.cdanimal and re.cdraca = 365 and percentual = 100)>0)
    then 'gir'
    when ((select first 1 re.cdraca from animalraca re where re.cdanimal = an.cdanimal and re.cdraca = 385 and percentual = 100)>0)
    then 'jersey'
    when (((select first 1 re.cdraca from animalraca re where re.cdanimal = an.cdanimal and re.cdraca = 365 and percentual = 75)>0)
      and ((select first 1 re.cdraca from animalraca re where re.cdanimal = an.cdanimal and re.cdraca = 385 and percentual = 25)>0))
    then '3/4 holandes 1/4 jersey'
    when (((select first 1 re.cdraca from animalraca re where re.cdanimal = an.cdanimal and re.cdraca = 365 and percentual = 50)>0)
      and ((select first 1 re.cdraca from animalraca re where re.cdanimal = an.cdanimal and re.cdraca = 385 and percentual = 50)>0))
    then '1/2 sangue holandes 1/2 sangue jersey'
  else 'Outras' end) as raca
  , an.sexo as sexo
  , pai.nome as nome_pai
  , (select idweb from fazenda) || LPAD(an.cdmae,  6, '0') as codigo_mae
  , (case
      when extract(day from an.dtnascimento) < 10
        then '0'|| extract(day from an.dtnascimento)
      else extract(day from an.dtnascimento) end)
    || '/'
    || (case
      when extract(month from an.dtnascimento) < 10
        then '0' || extract(month from an.dtnascimento)
      else extract(month from an.dtnascimento) end)
    || '/'
    || extract(year from an.dtnascimento) as data_nascimento
  , (coalesce(an.numpartoentrada, 0) + coalesce((select count(*) from lactacao where cdanimal = an.cdanimal), 0)) as numero_lactacoes
  , (select count(*)
    from reproducao
    where cdanimal = an.cdanimal
      and cdtiporeproducao = any (select cdtiporeproducao from tiporeproducao where cdtiporeproducao < 4)
      and data > coalesce(lac.dtinicio, '1900-01-01')) as numero_ia
  , gr.descricao as lote
from
  animal an
  left join sp_categoriaanimal(current_date, ' cdanimal = '  || an.cdanimal) cat on 1 = 1
  left join sp_calculagrausangue(an.cdanimal) rc on 1 = 1
  left join animal pai on pai.cdanimal = an.cdpai
  left join animal mae on mae.cdanimal = an.cdmae
  left join lactacao lac on lac.cdlactacao =
    (select first 1 re.cdlactacao
    from lactacao re
    where re.cdanimal = an.cdanimal
    order by re.dtinicio desc)
  left join sp_grupoanimalespecifico(current_date, (select valor from configuracao where nome = 'TipoGrupoPrincipal'), an.cdanimal) gr on 1 = 1
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is NULL
order by
  an.numordenado