select
  (select idweb from fazenda) || LPAD(an.cdanimal,  6, '0')  as codigo_animal
  , ccs.dtanaliseleite as data_ultima_ccs
  , ccs.ccs as ultima_ccs
  , ccs2.dtanaliseleite as data_penultima_ccs
  , ccs2.ccs as penultima_ccs
  , ccs3.dtanaliseleite as data_antepenultima_ccs
  , ccs3.ccs as antepenultima_ccs
from
  animal an
  join lactacao lac on lac.cdlactacao =
      (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal order by re.dtinicio desc)
  left join reproducao ultpar on ultpar.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao = 7 order by re.data desc)
  join categoria catrep on catrep.cdcategoria =
    (select sp.creprodutiva from sp_categoriaanimal(current_date, 'cdanimal = ' || an.cdanimal) sp)
  left join reproducao diagp on diagp.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.diagnostico = 'P' order by re.data desc)
  left join analiseleite ccs on ccs.cdanaliseleite =
    (select first 1 re.cdanaliseleite from analiseleite re where re.cdanimal = lac.cdanimal and re.dtanaliseleite >= lac.dtinicio and re.ccs > 0 order by re.dtanaliseleite desc)
  left join analiseleite ccs2 on ccs2.cdanaliseleite =
    (select first 1 re.cdanaliseleite from analiseleite re where re.cdanimal = lac.cdanimal and re.dtanaliseleite >= lac.dtinicio and re.ccs > 0 and re.dtanaliseleite < ccs.dtanaliseleite order by re.dtanaliseleite desc)
  left join analiseleite ccs3 on ccs3.cdanaliseleite =
    (select first 1 re.cdanaliseleite from analiseleite re where re.cdanimal = lac.cdanimal and re.dtanaliseleite >= lac.dtinicio and re.ccs > 0 and re.dtanaliseleite < ccs2.dtanaliseleite order by re.dtanaliseleite desc)
  left join leite le on le.cdleite =
    (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao order by re.dtleite desc)
  left join mamite cult1 on cult1.cdmamite =
    (select first 1 re.cdmamite from mamite re where re.cdanimal = lac.cdanimal and re.data >= lac.dtinicio and ((re.cdmicroorganismo1 is not null) or (re.cdmicroorganismo2 is not null)) order by re.data asc)
  left join mamite cult2 on cult2.cdmamite =
    (select first 1 re.cdmamite from mamite re where re.cdanimal = lac.cdanimal and re.data >= lac.dtinicio and ((re.cdmicroorganismo1 is not null) or (re.cdmicroorganismo2 is not null))
            and re.data > cult1.data order by re.data asc)
  left join mamite cult3 on cult3.cdmamite =
    (select first 1 re.cdmamite from mamite re where re.cdanimal = lac.cdanimal and re.data >= lac.dtinicio and ((re.cdmicroorganismo1 is not null) or (re.cdmicroorganismo2 is not null))
            and re.data > cult2.data order by re.data asc)
where
  an.dtbaixa is null
  and an.cdcategoria = 7
order by an.numordenado
