select
  (select idweb from fazenda) || LPAD(an.cdanimal,  6, '0')  as codigo_animal
  , (case
      when extract(day from dig.data) < 10
        then '0'|| extract(day from dig.data)
      else extract(day from dig.data) end)
    || '/'
    || (case
      when extract(month from dig.data) < 10
        then '0' || extract(month from dig.data)
      else extract(month from dig.data) end)
    || '/'
    || extract(year from dig.data) as data_diagnostico
  , (case dig.diagnostico
    when 'P' then 'POSITIVO'
    when 'N' then 'NEGATIVO'
  else null end) as resultado_diagnostico
from animal an
  join reproducao dig on dig.cdreproducao =
    (select first 1 re.cdreproducao
    from reproducao re
    where re.cdanimal = an.cdanimal
      and re.cdtiporeproducao = 4
      and re.diagnostico is not null
    order by re.data desc)
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is NULL
  and an.dtnascimento between '1900-01-01' and current_date
  and dig.data >= coalesce((select first 1 dtinicio from lactacao where cdanimal = an.cdanimal order by dtinicio desc), an.dtnascimento)
  --COALESCE(AN.DTBAIXA, '2200-12-31') > (CURRENT_DATE - 31)
order by an.numordenado, dig.data
