select
  (select idweb from fazenda) || LPAD(an.cdanimal,  6, '0')  as codigo_animal
  , (case
      when extract(day from tent.data) < 10
        then '0'|| extract(day from tent.data)
      else extract(day from tent.data) end)
    || '/'
    || (case
      when extract(month from tent.data) < 10
        then '0' || extract(month from tent.data)
      else extract(month from tent.data) end)
    || '/'
    || extract(year from tent.data) as data_inseminacao
  , tou.nome as nome_touro
  , ins.nome as nome_inseminador
  , (case
    when tent.cdtiporeproducao = 1 and tent.cdprotocoloiatf is not null then 'IATF'
    when tent.cdtiporeproducao = 1 and tent.cdprotocoloiatf is null then 'IA'
    when tent.cdtiporeproducao = 2 then 'MONTA NATURAL'
    when tent.cdtiporeproducao = 3 and tent.cdprotocoloiatf is not null then 'TETF'
    when tent.cdtiporeproducao = 3 and tent.cdprotocoloiatf is null then 'FIV'
  else null end) as tipo_cobertura
from animal an
  join reproducao tent on tent.cdtiporeproducao in (1,2,3) and tent.cdanimal = an.cdanimal
  left join animal tou on tou.cdanimal = tent.cdreprodutor
  left join pessoa ins on ins.cdpessoa = tent.cdpessoa
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is NULL
  and an.dtnascimento between '1900-01-01' and current_date
  and tent.data >= coalesce((select first 1 dtinicio from lactacao where cdanimal = an.cdanimal order by dtinicio desc), an.dtnascimento)
  -- TENT.DATA BETWEEN (CURRENT_DATE - 31) AND (CURRENT_DATE)
order by 1, 2