select
  (select idweb from fazenda) || LPAD(an.cdanimal,  6, '0')  as codigo_animal
  , (case
      when extract(day from mad.data) < 10
        then '0'|| extract(day from mad.data)
      else extract(day from mad.data) end)
    || '/'
    || (case
      when extract(month from mad.data) < 10
        then '0' || extract(month from mad.data)
      else extract(month from mad.data) end)
    || '/'
    || extract(year from mad.data) as data_evento
  , 'AD' as teto
  , (case mad.ad
    when 0 then '1'
    when 1 then '2'
    when 2 then '3'
  else null end) as grau_severidade
  , coalesce(p1.nome, pa1.nome) as medicamento_1
  , coalesce(p2.nome, pa2.nome) as medicamento_2
  , coalesce(p3.nome, pa3.nome) as medicamento_3
  , '' as data_fim_tratamento
  , '' as curou
from animal an
  join mamite mad on mad.cdanimal = an.cdanimal and mad.ad in (0,1,2)
  left join tratamentobase t on t.cdtratamentobase = mad.cdtratamentobase
  left join produto p1 on p1.cdproduto = t.cdproduto1
  left join produto p2 on p2.cdproduto = t.cdproduto2
  left join produto p3 on p3.cdproduto = t.cdproduto3
  left join principioativo pa1 on pa1.cdprincipioativo = t.cdprincipioativo1
  left join principioativo pa2 on pa2.cdprincipioativo = t.cdprincipioativo2
  left join principioativo pa3 on pa3.cdprincipioativo = t.cdprincipioativo3
where
  mad.data >= (select first 1 dtinicio from lactacao where cdanimal = an.cdanimal order by dtinicio desc)
  and an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is NULL
  and an.dtnascimento between '1900-01-01' and current_date
  -- MAD."DATA" >= (SELECT DTINICIO FROM LACTACAO WHERE DTFIM IS NULL AND CDANIMAL = AN.CDANIMAL)
  -- AND COALESCE(AN.DTBAIXA, '2200-12-31') > (CURRENT_DATE - 365)
union
select
  (select idweb from fazenda) || LPAD(an.cdanimal,  6, '0')  as codigo_animal
  , (case
      when extract(day from mad.data) < 10
        then '0'|| extract(day from mad.data)
      else extract(day from mad.data) end)
    || '/'
    || (case
      when extract(month from mad.data) < 10
        then '0' || extract(month from mad.data)
      else extract(month from mad.data) end)
    || '/'
    || extract(year from mad.data) as data_evento
  , 'AE' as teto
  , (case mad.ae
    when 0 then '1'
    when 1 then '2'
    when 2 then '3'
  else null end) as grau_severidade
  , coalesce(p1.nome, pa1.nome) as medicamento_1
  , coalesce(p2.nome, pa2.nome) as medicamento_2
  , coalesce(p3.nome, pa3.nome) as medicamento_3
  , '' as data_fim_tratamento
  , '' as curou
from animal an
  join mamite mad on mad.cdanimal = an.cdanimal and mad.ae in (0,1,2)
  left join tratamentobase t on t.cdtratamentobase = mad.cdtratamentobase
  left join produto p1 on p1.cdproduto = t.cdproduto1
  left join produto p2 on p2.cdproduto = t.cdproduto2
  left join produto p3 on p3.cdproduto = t.cdproduto3
  left join principioativo pa1 on pa1.cdprincipioativo = t.cdprincipioativo1
  left join principioativo pa2 on pa2.cdprincipioativo = t.cdprincipioativo2
  left join principioativo pa3 on pa3.cdprincipioativo = t.cdprincipioativo3
where
  mad.data >= (select first 1 dtinicio from lactacao where cdanimal = an.cdanimal order by dtinicio desc)
  and an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is NULL
  and an.dtnascimento between '1900-01-01' and current_date
  -- MAD."DATA" >= (SELECT DTINICIO FROM LACTACAO WHERE DTFIM IS NULL AND CDANIMAL = AN.CDANIMAL)
  -- AND COALESCE(AN.DTBAIXA, '2200-12-31') > (CURRENT_DATE - 365)
union
select
  (select idweb from fazenda) || LPAD(an.cdanimal,  6, '0')  as codigo_animal
  , (case
      when extract(day from mad.data) < 10
        then '0'|| extract(day from mad.data)
      else extract(day from mad.data) end)
    || '/'
    || (case
      when extract(month from mad.data) < 10
        then '0' || extract(month from mad.data)
      else extract(month from mad.data) end)
    || '/'
    || extract(year from mad.data) as data_evento
  , 'PD' as teto
  , (case mad.pd
    when 0 then '1'
    when 1 then '2'
    when 2 then '3'
  else null end) as grau_severidade
  , coalesce(p1.nome, pa1.nome) as medicamento_1
  , coalesce(p2.nome, pa2.nome) as medicamento_2
  , coalesce(p3.nome, pa3.nome) as medicamento_3
  , '' as data_fim_tratamento
  , '' as curou
from animal an
  join mamite mad on mad.cdanimal = an.cdanimal and mad.pd in (0,1,2)
  left join tratamentobase t on t.cdtratamentobase = mad.cdtratamentobase
  left join produto p1 on p1.cdproduto = t.cdproduto1
  left join produto p2 on p2.cdproduto = t.cdproduto2
  left join produto p3 on p3.cdproduto = t.cdproduto3
  left join principioativo pa1 on pa1.cdprincipioativo = t.cdprincipioativo1
  left join principioativo pa2 on pa2.cdprincipioativo = t.cdprincipioativo2
  left join principioativo pa3 on pa3.cdprincipioativo = t.cdprincipioativo3
where
  mad.data >= (select first 1 dtinicio from lactacao where cdanimal = an.cdanimal order by dtinicio desc)
  and an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is NULL
  and an.dtnascimento between '1900-01-01' and current_date
  -- MAD."DATA" >= (SELECT DTINICIO FROM LACTACAO WHERE DTFIM IS NULL AND CDANIMAL = AN.CDANIMAL)
  -- AND COALESCE(AN.DTBAIXA, '2200-12-31') > (CURRENT_DATE - 365)
union
select
  (select idweb from fazenda) || LPAD(an.cdanimal,  6, '0')  as codigo_animal
  , (case
      when extract(day from mad.data) < 10
        then '0'|| extract(day from mad.data)
      else extract(day from mad.data) end)
    || '/'
    || (case
      when extract(month from mad.data) < 10
        then '0' || extract(month from mad.data)
      else extract(month from mad.data) end)
    || '/'
    || extract(year from mad.data) as data_evento
  , 'PE' as teto
  , (case mad.pe
    when 0 then '1'
    when 1 then '2'
    when 2 then '3'
  else null end) as grau_severidade
  , coalesce(p1.nome, pa1.nome) as medicamento_1
  , coalesce(p2.nome, pa2.nome) as medicamento_2
  , coalesce(p3.nome, pa3.nome) as medicamento_3
  , '' as data_fim_tratamento
  , '' as curou
from animal an
  join mamite mad on mad.cdanimal = an.cdanimal and mad.pe in (0,1,2)
  left join tratamentobase t on t.cdtratamentobase = mad.cdtratamentobase
  left join produto p1 on p1.cdproduto = t.cdproduto1
  left join produto p2 on p2.cdproduto = t.cdproduto2
  left join produto p3 on p3.cdproduto = t.cdproduto3
  left join principioativo pa1 on pa1.cdprincipioativo = t.cdprincipioativo1
  left join principioativo pa2 on pa2.cdprincipioativo = t.cdprincipioativo2
  left join principioativo pa3 on pa3.cdprincipioativo = t.cdprincipioativo3
where
  mad.data >= (select first 1 dtinicio from lactacao where cdanimal = an.cdanimal order by dtinicio desc)
  and an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is NULL
  and an.dtnascimento between '1900-01-01' and current_date
  -- MAD."DATA" >= (SELECT DTINICIO FROM LACTACAO WHERE DTFIM IS NULL AND CDANIMAL = AN.CDANIMAL)
  -- AND COALESCE(AN.DTBAIXA, '2200-12-31') > (CURRENT_DATE - 365)