select
  (select idweb from fazenda) || LPAD(an.cdanimal,  6, '0')  as codigo_animal
  , an.dtbaixa as data_movimentacao
  , cast((case
    when an.cdtipobaixa = 2 then upper('Descarte')
    when an.cdtipobaixa = 3 then upper('Morte')
    when an.cdmotivobaixa = 89 then upper('Venda')
    else upper('Morte') end) as varchar(100)) as tipo_movimentacao
  , cast((case
    when an.cdmotivobaixa in (select cdmotivobaixa
                              from motivobaixa
                              where upper(descricao) like '%MASTITE%') then upper('mastite')
    when an.cdmotivobaixa in (select cdmotivobaixa
                              from motivobaixa
                              where upper(descricao) like '%REPRODU%') then upper('reprodução')
    when an.cdmotivobaixa in (select cdmotivobaixa
                              from motivobaixa
                              where upper(descricao) like '%CASCO%') then upper('casco')
    when an.cdmotivobaixa in (select cdmotivobaixa
                              from motivobaixa
                              where upper(descricao) like '%PARTO%') then upper('problemas parto')
    when an.cdmotivobaixa in (select cdmotivobaixa
                              from motivobaixa
                              where upper(descricao) like '%PNEUMONIA%') then upper('pnuemonia')
    when an.cdmotivobaixa in (select cdmotivobaixa
                              from motivobaixa
                              where upper(descricao) like '%DIARR%IA%') then upper('diarreia')
    when an.cdmotivobaixa in (select cdmotivobaixa
                              from motivobaixa
                              where upper(descricao) like '%METAB%LICA%') then upper('doencas metabalicas')
    when an.cdmotivobaixa in (select cdmotivobaixa
                              from motivobaixa
                              where upper(descricao) like '%PRODUÇÃO%') then upper('produção')
    when an.cdmotivobaixa in (select cdmotivobaixa
                              from motivobaixa
                              where upper(descricao) like 'ACIDENTE') then upper('acidente')
    else upper('outros') end) as varchar(100)) as motivo_movimentacao
  , cast(null as varchar(100)) as novo_lote
from
  animal an
where
  an.dtbaixa is not null
  AND AN.DTBAIXA BETWEEN (CURRENT_DATE - 31) AND (CURRENT_DATE)
union
select
  (select idweb from fazenda) || LPAD(an.cdanimal,  6, '0')  as codigo_animal
  , mg.dtmovimentacao as data_movimentacao
  , cast(upper('Mudaca de lote') as varchar(100)) as tipo_movimentacao
  , cast(upper('outros') as varchar(100)) as motivo_movimentacao
  , cast(g.descricao as varchar(100)) as novo_lote
from
  animal an
  join movgrupoanimal mga on mga.cdanimal = an.cdanimal
  join movgrupo mg on mg.cdmovgrupo = mga.cdmovgrupo
    and mg.cdtipogrupoanimal = (select valor from configuracao where nome = 'TipoGrupoPrincipal')
  join grupoanimal g on g.cdgrupoanimal = mg.cdgrupoanimal
WHERE 
 mg.dtmovimentacao between '1900-01-01' and '2200-12-31'
--  MG.DTMOVIMENTACAO BETWEEN (CURRENT_DATE - 31) AND (CURRENT_DATE)
  and an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is NULL
  and an.dtnascimento between '1900-01-01' and current_date
order by 1, 2