select
  (select idweb from fazenda) || LPAD(an.cdanimal,  6, '0')  as codigo_animal
  , (case
      when extract(day from par.data) < 10
        then '0'|| extract(day from par.data)
      else extract(day from par.data) end)
    || '/'
    || (case
      when extract(month from par.data) < 10
        then '0' || extract(month from par.data)
      else extract(month from par.data) end)
    || '/'
    || extract(year from par.data) as data_parto
  , (case par.cdtipoparto
    when 1 then upper('Normal')
    when 2 then (case par.cdauxilioparto
                 when 2 then upper('CesÁrea')
                 else upper('AuxÍlio') end)
    when 3 then upper('Aborto')
    else upper('Normal') end) as tipo_parto
  , (case par.numcria
    when 1 then upper('NÃo')
    when 2 then upper('Sim')
    else upper('NÃo') end) as gemelar
  , (case par.retencaoplacenta
    when 1 then upper('Sim')
    when 0 then upper('NÃo')
    else null end) as retencao_placenta
  , coalesce(par.sexocria1, cria1.sexo)  as sexo_cria
  , pcria.peso as peso_cria
  , ((select idweb from fazenda) || LPAD(cria1.cdanimal,  6, '0'))as codigo_cria
  , ((select idweb from fazenda) || LPAD(cria2.cdanimal,  6, '0'))as codigo_cria2
  , (select grausangue from sp_calculagrausangue(cria1.cdanimal)) as raca_cria
  , gr.descricao as lote_cria
from
  animal an
  join reproducao par on par.cdreproducao =
    (select first 1 re.cdreproducao
    from reproducao re
    where re.cdanimal = an.cdanimal
      and re.cdtiporeproducao = 7
    order by re.data desc)
  left join animal cria1 on cria1.cdanimal =
    (select first 1 re.cdanimal
    from animal re
    where re.cdreproducao = par.cdreproducao)
  left join animal cria2 on cria2.cdanimal =
    (select first 1 re.cdanimal
    from animal re
    where re.cdreproducao = par.cdreproducao
      and re.cdanimal <> cria1.cdanimal)
  left join peso pcria on pcria.cdpeso =
    (select first 1 re.cdpeso
    from peso re
    where re.cdanimal = cria1.cdanimal
      and re.cdtipopeso in (1,2)
    order by re.dtpeso asc)
left join sp_grupoanimalespecifico(current_date, (select valor from configuracao where nome = 'TipoGrupoPrincipal'), cria1.cdanimal) gr on 1 = 1
WHERE
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is NULL
  and an.dtnascimento between '1900-01-01' and current_date
 --  COALESCE(AN.DTBAIXA, '2200-12-31') > (CURRENT_DATE - 31)