select
  (select idweb from fazenda) || LPAD(an.cdanimal,  6, '0')  as codigo_animal
  , (case
      when extract(day from d1.dtinicio) < 10
        then '0'|| extract(day from d1.dtinicio)
      else extract(day from d1.dtinicio) end)
    || '/'
    || (case
      when extract(month from d1.dtinicio) < 10
        then '0' || extract(month from d1.dtinicio)
      else extract(month from d1.dtinicio) end)
    || '/'
    || extract(year from d1.dtinicio) as data_evento
  , (case
    when upper(d2.nomecompleto) like '%REPIRAT%RIA%' then 'doença respiratória'
    when upper(d2.nomecompleto) like '%PNEUMONIA%' then 'doença respiratória'
    when upper(d2.nomecompleto) like '%TRISTEZA%' then 'TPB (tristeza parasitária bovina)'
    when upper(d2.nomecompleto) like '%DIARR%IA%' then 'diarreia'
    when upper(d2.nomecompleto) like '%CASCO%' then 'casco'
    when upper(d2.nomecompleto) like '%HIPOCALCEMIA%' then 'hipocalcemia'
    when upper(d2.nomecompleto) like '%CDRATOCONJUNTIVITE%' then 'ceratoconjuntivite'
    when upper(d2.nomecompleto) like '%DESLOCAMENTO%ABOMASO%' then 'deslocamento de abomaso'
    when upper(d2.nomecompleto) like '%CETOSE%' then 'cetose'
    when upper(d2.nomecompleto) like '%METRITE%' then 'metrite'
    when upper(d2.nomecompleto) like '%EDEMA%BERE%' then 'edema de úbere'
    when par.retencaoplacenta = 1 then 'retenção placenta'
  else 'outras' end) as diagnostico
  , p1.nome as medicamento_1
  , p2.nome as medicamento_2
  , p3.nome as medicamento_3
  , '' as curou
from animal an
  join doencaanimal d1 on d1.cdanimal = an.cdanimal
  join doenca d2 on d2.cddoenca = d1.cddoenca
  left join reproducao par on par.cdanimal = an.cdanimal
    and par.cdtiporeproducao = 7
    and par.retencaoplacenta = 1
  left join aplicacaoproduto m1 on m1.cdaplicacaoproduto =
    (select first 1 re.cdaplicacaoproduto
    from aplicacaoproduto re
    where re.cdanimal = an.cdanimal
      and re.dtaplicacaoproduto <= (d1.dtinicio + 3)
    order by re.dtaplicacaoproduto asc)
  left join produto p1 on p1.cdproduto = m1.cdproduto
  left join aplicacaoproduto m2 on m2.cdaplicacaoproduto =
    (select first 1 re.cdaplicacaoproduto
    from aplicacaoproduto re
    where re.cdanimal = an.cdanimal
      and re.dtaplicacaoproduto <= (d1.dtinicio + 3)
      and re.cdaplicacaoproduto <> m1.cdaplicacaoproduto
    order by re.dtaplicacaoproduto asc)
  left join produto p2 on p2.cdproduto = m2.cdproduto  
  left join aplicacaoproduto m3 on m3.cdaplicacaoproduto =
    (select first 1 re.cdaplicacaoproduto
    from aplicacaoproduto re
    where re.cdanimal = an.cdanimal
      and re.dtaplicacaoproduto <= (d1.dtinicio + 3)
      and re.cdaplicacaoproduto <> m1.cdaplicacaoproduto
      and re.cdaplicacaoproduto <> m2.cdaplicacaoproduto
    order by re.dtaplicacaoproduto asc)
  left join produto p3 on p3.cdproduto = m3.cdproduto 
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is NULL
  and an.dtnascimento between '1900-01-01' and current_date
  and d1.dtinicio > coalesce((select first 1 dtinicio from lactacao where cdanimal = an.cdanimal order by dtinicio desc), an.dtnascimento)
  -- D1.DTINICIO > (CURRENT_DATE - 365)