select
  (select idweb from fazenda) || LPAD(an.cdanimal,  6, '0')  as codigo_animal
  , (case
      when extract(day from sec.dtfim) < 10
        then '0'|| extract(day from sec.dtfim)
      else extract(day from sec.dtfim) end)
    || '/'
    || (case
      when extract(month from sec.dtfim) < 10
        then '0' || extract(month from sec.dtfim)
      else extract(month from sec.dtfim) end)
    || '/'
    || extract(year from sec.dtfim) as data_secagem
  , (case sec.cdmotivosecagem
    when 5 then 'ROTINA'
    when 1 then 'BAIXA PRODUÇÃO'
    when 3 then 'MASTITE'
  else 'OUTROS' end) as motivo_secagem
  , p.nome as produto
from animal an
  join lactacao sec on sec.cdlactacao =
    (select first 1 re.cdlactacao
    from lactacao re
    where re.cdanimal = an.cdanimal
    order by re.dtinicio desc)
  left join aplicacaoproduto ap on ap.cdaplicacaoproduto =
    (select first 1 re1.cdaplicacaoproduto
    from aplicacaoproduto re1
    where re1.cdanimal = sec.cdanimal
      and re1.dtaplicacaoproduto = sec.dtfim
    order by re1.cdaplicacaoproduto asc)
  left join produto p on p.cdproduto = coalesce(sec.cdproduto, ap.cdproduto)
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is null
  and sec.dtfim is not null
  -- COALESCE(AN.DTBAIXA, '2200-12-31') > (CURRENT_DATE - 31)